#!python
# -*- coding: utf-8 -*-
__version__ = "$Revision: 1.1 $"
# $Source: /home/mechanoid/projects/py/cv/classifier-detector/detector-hog/lib/RCS/svm.py,v $
#
#       OS : GNU/Linux 4.10.3-1-ARCH 
# COMPILER : Python 3.6.0
#
#   AUTHOR : Evgeny S. Borisov
# 
#    http://www.mechanoid.kiev.ua
#  e-mail : nn@mechanoid.kiev.ua
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
import cv2
import numpy as np


# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = 
class ImageClassificator:

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    def __init__(self,extractor,classificator):
        self.model = classificator 
        self.extractor = extractor
        
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    def train(self,X,y):
        print("[i] обучаем классификатор ...")
        # self.model.setTermCriteria((cv2.TERM_CRITERIA_COUNT, 500, 1e-2))
        self.model.train( X, cv2.ml.ROW_SAMPLE, y )

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    def save(self, f="result/model.xml"): 
        self.model.save(f)

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    def test( self, X, y ):
        print("[i] тестируем классификатор ...")
        _,o = self.model.predict(X)
        r = np.sum( o != y )
        print( "\tколичество ошибок на тестовом наборе: %i из %i"%(r,X.shape[0]) )

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    def predict(self,img, img_resize=(100,40) ):
        h = self.extractor.extract(img)
        x = np.asarray([h],dtype=np.float32)
        _, o = self.model.predict( x, flags = cv2.ml.STAT_MODEL_RAW_OUTPUT )
        return o[0][0]


# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = 
class ImageClassificatorSVM(ImageClassificator):
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    def __init__(self,extractor):
        model = cv2.ml.SVM_create()
        model.setKernel(cv2.ml.SVM_RBF)
        # model.setKernel(cv2.ml.SVM_LINEAR )
        super().__init__(extractor,model)

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    def load(self, f="result/model.xml"):  
        self.model = cv2.ml.SVM_load(f)
        
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    def predict(self,img, img_resize=(100,40) ):
        h = self.extractor.extract(img)
        x = np.asarray([h],dtype=np.float32)
        _, o = self.model.predict( x, flags = cv2.ml.STAT_MODEL_RAW_OUTPUT )
        #print(o)
        return -o[0][0]

