#!python
# -*- coding: utf-8 -*-
__version__ = "$Revision: 1.2 $"
# $Source: /home/mechanoid/projects/py/cv/classifier-detector/lib/mymodule/RCS/extractor.py,v $
#
#       OS : GNU/Linux 4.10.3-1-ARCH 
# COMPILER : Python 3.6.0
#
#   AUTHOR : Evgeny S. Borisov
# 
#    http://www.mechanoid.kiev.ua
#  e-mail : nn@mechanoid.kiev.ua
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
import cv2
import numpy as np
import glob
import os

# = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = 
class ExtractorHoG:

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    def __init__( self, img_size=(100,40), cell_size=(10,8), block_size=(10,5), nbins=9 ):
        #self.cell_size = cell_size  # h x w in pixels
        #self.block_size = block_size  # h x w in cells
        #self.window_size = window_size
             
        self.img_size=img_size
        w,h = img_size
        cw,ch = cell_size
        bw,bh = block_size

        self.nbins = nbins  # number of orientation bins
        self.winSize = ( (w // cw) * cw, (h // ch) * ch)
        self.blockSize = ( bw*cw, bh*ch )
        self.blockStride = (cw, ch)
        self.cellSize=(cw, ch)

        self.hog = cv2.HOGDescriptor(
                _winSize=self.winSize,
                _blockSize=self.blockSize,
                _blockStride=self.blockStride,
                _cellSize=self.cellSize,
                _nbins=self.nbins )

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    def load(self,f="result/hog.npz"):
        npzfile = np.load(f)
        self.winSize = tuple(npzfile["_winSize"])
        self.blockSize = tuple(npzfile["_blockSize"])
        self.blockStride = tuple(npzfile["_blockStride"])
        self.cellSize = tuple(npzfile["_cellSize"])
        self.nbins = npzfile["_nbins"]
        self.img_size = npzfile["_img_size"]

        self.hog = cv2.HOGDescriptor(
                _winSize=self.winSize,
                _blockSize=self.blockSize,
                _blockStride=self.blockStride,
                _cellSize=self.cellSize,
                _nbins=self.nbins )
 
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    def save(self, f="result/hog.npz"):
        np.savez( f, 
                 _winSize=self.winSize, 
                 _blockSize=self.blockSize,
                 _blockStride=self.blockStride,
                 _cellSize=self.cellSize,
                 _nbins=self.nbins,
                 _img_size=self.img_size )

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
    def extract(self, img): 
        h = self.hog.compute( img, locations=((0,0),) )
        return h.ravel().tolist()




