#!python
# -*- coding: utf-8 -*-
__version__ = "$Revision: 1.16 $"
# $Source: /home/mechanoid/projects/py/cv/classifier-detector/hog/RCS/main.py,v $
#
#       OS : GNU/Linux 4.10.3-1-ARCH 
# COMPILER : Python 3.6.0
#
#   AUTHOR : Evgeny S. Borisov
# 
#    http://www.mechanoid.kiev.ua
#  e-mail : nn@mechanoid.kiev.ua
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

import sys
import numpy as np
import cv2
import glob
import os

from extractor import ExtractorHoG
from data import MLTrainData
from classificator import ImageClassificatorSVM
from detector import Detector


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
def main():
    # создаём feature extractor 
    extractor = ExtractorHoG()

    # генерируем учебный набор для классификатора
    data = MLTrainData(extractor)
    data.make( dir_pos=[["data/train/pos/*",1.0], ], 
               dir_neg=[["data/train/neg/*",1.0], ],
               part = [ 0.0, 0.2 ] )

    data.save( "result/data.npz" )

    # сохраняем параметры feature extractor 
    extractor.save( "result/hog.npz" )
    
    # обучаем классификатор
    cls = ImageClassificatorSVM( extractor )
    cls.train( data.X_train, data.y_train )
    cls.save( "result/model.xml")
    cls.test( data.X_test, data.y_test )

    detector = Detector(cls, classificator_threshold = 0.95)
 
    ff = glob.glob("data/test/*")
    #ind = np.random.permutation(len(ff)) [ 0 : 7 ]  
    #ff =  [ ff[i] for i in ind ]
    i=1
    for f in ff:
        print("%i/%i: %s                "%(i,len(ff),f),end='\r')
        i+=1
        img = cv2.imread(f,cv2.IMREAD_GRAYSCALE) # 100x40
        detector.search(img)
        img2 = detector.draw_boxes(img)
        nm = os.path.splitext(os.path.basename(f))[0]
        cv2.imwrite("result/%s.png"%nm,img2)
    print("\n")

 
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
if __name__ == "__main__":
    print("OpenCV ",cv2.__version__)
    sys.exit(main())





